/*******************************************************************************/
//  Bernard Lidicky - 1999
//  Hippo Games
//  PiskII
//  PiskII.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "PiskII.h"
// casti hry
#include "menu.h"
#include "bbuttonek.h"


#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


CPiskIIApp theApp;
CDXScreen screen;
CDXInput  input;


/*******************************************************************************/
BEGIN_MESSAGE_MAP(CPiskIIApp, CWinApp)
	//{{AFX_MSG_MAP(CPiskIIApp)
	//}}AFX_MSG
END_MESSAGE_MAP()
/*******************************************************************************/
CPiskIIApp::CPiskIIApp()
{
	srand((unsigned)time(NULL));  // inicializace generatoru nahodnych cisel
}
/*******************************************************************************/
CPiskIIApp::~CPiskIIApp()
{

}	
/*******************************************************************************/
BOOL CPiskIIApp::InitInstance()
{
	ZobrazKurzor(FALSE);
#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	SetRegistryKey(_T("Hippo Games")); // nastaveni klice k registrum

	CMainFrame* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;
	pFrame->ShowWindow(SW_SHOW);

	// CDX init
	if (screen.CreateFullScreen(m_pMainWnd->m_hWnd,640,480,16)  == FALSE) return FALSE;
	screen.FadeToBlack(0);
	if (input.Create(m_hInstance,m_pMainWnd->m_hWnd,FALSE) == 0) return FALSE;
 
	pFrame->UpdateWindow();
	pFrame->SendMessage(WM_INITED); // oznamime inicializaci

	return TRUE;
}
/*******************************************************************************/
int Nahoda(int kolik)
{
	return (rand()*kolik/RAND_MAX);
}
/******************************************************************************/
double abs(double co){
	if(co >= 0) return co;
	return -co;
}
/******************************************************************************/
void ZobrazKurzor(BOOL yes){
	static int sh = 0;
	if(yes == TRUE) while(sh < 0){ 
		ShowCursor(TRUE); 
		sh++;
	}
	else while(sh >= 0){ 
		ShowCursor(FALSE); 
		sh--;
	}
}
