/*******************************************************************************/
//  Bernard Lidicky - 1999
//  Hippo Games
//  PiskII
//  Menu1.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "bbuttonek.h"
#include "PiskII.h"
#include "Menu.h"
#include "CreateCon.h"

//******************************************************************************
CMenu1::CMenu1()
{
/*	BButtonek *m_bP1m; // Player 1 minus
	BButtonek *m_bP1p; // Player 1 plus
	BButtonek *m_bP2m; // Player 2 minus
	BButtonek *m_bP2p; // Player 2 plus
	BButtonek *m_bPlay; // Zacatek hry
	BButtonek *m_bExit; // konec hry
*/
	m_bP1m = new BButtonek;
	m_bP1m->srect.SetRect(30,190,80 ,290);
	m_bP1p = new BButtonek;
	m_bP1p->srect.SetRect(170,190,220,290);

	m_bPlay = new BButtonek;
	m_bPlay->srect.SetRect(240,180,400,300);

	m_bP2m = new BButtonek;
	m_bP2m->srect.SetRect(420,190,470,290);
	m_bP2p = new BButtonek;
	m_bP2p->srect.SetRect(560,190,610,290);

	m_bExit = new BButtonek;
	m_bExit->srect.SetRect(30,400,100,480);

	m_bMulti = new BButtonek;
	m_bMulti->srect.SetRect(0,0,100,100);

	lpDDMenu.m_lpDDS = DDLoadBitmapB(screen.m_lpDD,"IDB_MENU",0,0,AfxGetApp()->m_hInstance); 
	if (lpDDMenu.m_lpDDS == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_CLOSE);
	lpDDMenu.SetColorKey(RGB(255,0,255));
	lpDDMenu.SetSrc(0,0,480,640);
	lpDDMenu.SetDest(0,0,480,640);

	lpDDColor.m_lpDDS = DDLoadBitmapB(screen.m_lpDD,"IDB_PL",0,0,AfxGetApp()->m_hInstance); 
	if (lpDDColor.m_lpDDS == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_CLOSE);


	m_hAlpha[0] = (HBITMAP) ::LoadImage( AfxGetApp()->m_hInstance, "IDB_PL1_A", IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_DEFAULTSIZE);
   if (m_hAlpha[0] == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);

	m_hAlpha[1] = (HBITMAP) ::LoadImage( AfxGetApp()->m_hInstance, "IDB_PL2_A", IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_DEFAULTSIZE);
   if (m_hAlpha[1] == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);
	
	m_hAlpha[2] = (HBITMAP) ::LoadImage( AfxGetApp()->m_hInstance, "IDB_PL3_A", IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_DEFAULTSIZE);
   if (m_hAlpha[2] == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);

	m_hAlpha[3] = (HBITMAP) ::LoadImage( AfxGetApp()->m_hInstance, "IDB_PL4_A", IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_DEFAULTSIZE);
   if (m_hAlpha[3] == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);

	m_hAlpha[4] = (HBITMAP) ::LoadImage( AfxGetApp()->m_hInstance, "IDB_PL5_A", IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_DEFAULTSIZE);
   if (m_hAlpha[4] == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);

	m_hAlpha[5] = (HBITMAP) ::LoadImage( AfxGetApp()->m_hInstance, "IDB_PL6_A", IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_DEFAULTSIZE);
   if (m_hAlpha[5] == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);

	// init DDSURFACEDESC for the mask
	BITMAP bm;
	for(int i = 0; i < MODULSP; i++) {
		GetObject(m_hAlpha[i], sizeof(bm), &bm);
      m_DscAlpha[i].dwWidth   = bm.bmWidth;
      m_DscAlpha[i].dwHeight  = bm.bmHeight;
      m_DscAlpha[i].lPitch    = bm.bmWidthBytes;
      m_DscAlpha[i].lpSurface = bm.bmBits;
	}



	m_font.CreateFont(20,0,0,0,FW_BOLD,0,0,0,1,OUT_DEFAULT_PRECIS, 
						   CLIP_DEFAULT_PRECIS,PROOF_QUALITY,DEFAULT_PITCH,
							"Times New Roman"); // Verdena - Times New Roman

}
//******************************************************************************
CMenu1::~CMenu1()
{
	for(int i = 0; i < MODULSP; i++)
	   if (m_hAlpha[i] != NULL) DeleteObject(m_hAlpha[i]);

	delete m_bP1m; // Player 1 minus
	delete m_bP1p; // Player 1 plus
	delete m_bP2m; // Player 2 minus
	delete m_bP2p; // Player 2 plus
	delete m_bPlay; // Zacatek hry
	delete m_bExit; // konec hry
	delete m_bMulti; // multi play
}
//******************************************************************************
BOOL CMenu1::OnTimer()
{
	if(!m_flippig) return FALSE;

	CString s;
	CRect   rcRect;

	// vlozeni pozadi
	CRect rect;
	rect.SetRect(0,0,640,480);

	lpDDMenu.DrawFast(0,0,screen.m_lpDDSBack);
	
	// nakresleni hracu
	LockBuffers();
		alpha->AlphaBltEx(m_DscDst,90,170,m_DscColor,NULL,m_DscAlpha[m_pHra->m_hrac[0]]);
		alpha->AlphaBltEx(m_DscDst,480,170,m_DscColor,NULL,m_DscAlpha[m_pHra->m_hrac[1]]);
	UnlockBuffers();


/* buttonky se neprekresluji - jsou natvrdo na obrazovce
	m_b1Player->RedrawButton(screen.m_lpDDSBack->m_lpDDS,lpDDMenu.m_lpDDS);
	m_b2Players->RedrawButton(screen.m_lpDDSBack->m_lpDDS,lpDDMenu.m_lpDDS);
	m_bDead->RedrawButton(screen.m_lpDDSBack->m_lpDDS,lpDDMenu.m_lpDDS);
	m_bAbout->RedrawButton(screen.m_lpDDSBack->m_lpDDS,lpDDMenu.m_lpDDS);
	m_bExit->RedrawButton(screen.m_lpDDSBack->m_lpDDS,lpDDMenu.m_lpDDS);
*/
	return TRUE;
}
//******************************************************************************
void CMenu1::OnMouseMove(CPoint point)
{
	m_bP1m->MouseMove(point); 	
	m_bP1p->MouseMove(point); 	
	m_bP2m->MouseMove(point); 	
	m_bP2p->MouseMove(point); 	
	m_bPlay->MouseMove(point);	
	m_bExit->MouseMove(point);
	m_bMulti->MouseMove(point);
}
//******************************************************************************
void CMenu1::OnLButtonDown(CPoint point)
{
	m_bP1m->MouseLBDn(point); 	
	m_bP1p->MouseLBDn(point); 	
	m_bP2m->MouseLBDn(point); 	
	m_bP2p->MouseLBDn(point); 	
	m_bPlay->MouseLBDn(point);	
	m_bExit->MouseLBDn(point);
	m_bMulti->MouseLBDn(point); 	
}
//******************************************************************************
void CMenu1::OnLButtonUp(CPoint point)
{
	if(m_bP1m->MouseLBUp(point))
		if(--m_pHra->m_hrac[0] < 0)
			m_pHra->m_hrac[0] = MODULS;

	if(m_bP1p->MouseLBUp(point)) 	
		if(++m_pHra->m_hrac[0] > MODULS)
			m_pHra->m_hrac[0] = 0;
	
	if(m_bP2m->MouseLBUp(point))
		if(--m_pHra->m_hrac[1] < 0)
			m_pHra->m_hrac[1] = MODULS;
	
	if(m_bP2p->MouseLBUp(point)) 	
		if(++m_pHra->m_hrac[1] > MODULS)
			m_pHra->m_hrac[1] = 0;

	if(m_bPlay->MouseLBUp(point))
		AfxGetApp()->m_pMainWnd->PostMessage(WM_HRA, m_pHra->m_hrac[0], m_pHra->m_hrac[1]);

	if(m_bExit->MouseLBUp(point))
		AfxGetApp()->m_pMainWnd->PostMessage(WM_CLOSE);

	if(m_bMulti->MouseLBUp(point)) {
		CCreateCon dlg;
		screen.FlipToGDI();
		m_flippig = FALSE;
		if(dlg.DoModal(m_pHra) == IDOK){
			if(player.m_Flags == 0) // m_flag == 0 znamena server
				AfxGetApp()->m_pMainWnd->PostMessage(WM_HRA, CLOVEK, MODUL4);
			else 
				AfxGetApp()->m_pMainWnd->PostMessage(WM_HRA, MODUL4, CLOVEK);
		}
		m_flippig = TRUE;
	}

	// resetovani knofliku
	m_bP1m->stav_old = m_bP1m->stav = 0;
	m_bP1p->stav_old = m_bP1p->stav = 0;
	m_bP2m->stav_old = m_bP2m->stav = 0;
	m_bP2p->stav_old = m_bP2p->stav = 0;
	m_bExit->stav_old = m_bExit->stav = 0;
	m_bMulti->stav_old = m_bMulti->stav = 0;
}
//******************************************************************************
void CMenu1::Activate(CHra *p_hra)
{
	ZobrazKurzor(TRUE);
	m_flippig = TRUE;
	m_pHra = p_hra;

	// reset buttonku
	m_bP1m->stav_old = m_bP1m->stav = 0;
	m_bP1p->stav_old = m_bP1p->stav = 0;
	m_bP2m->stav_old = m_bP2m->stav = 0;
	m_bP2p->stav_old = m_bP2p->stav = 0;
	m_bExit->stav_old = m_bExit->stav = 0;
	m_bMulti->stav_old = m_bMulti->stav = 0;
}
//******************************************************************************
void CMenu1::OnKeyDown(UINT nChar)
{
	switch (nChar) {
	case VK_ESCAPE :
		AfxGetApp()->m_pMainWnd->PostMessage(WM_CLOSE);
		break;
	}
}
//******************************************************************************
void CMenu1::Restore()
{
}
//******************************************************************************
void CMenu1::LockBuffers()
{
	dxutil_InitStructure(m_DscColor);
	dxutil_InitStructure(m_DscDst);

	lpDDColor.m_lpDDS->Lock(NULL, &m_DscColor, DDLOCK_WAIT, NULL);
	screen.m_lpDDSBack->m_lpDDS->Lock(NULL, &m_DscDst, DDLOCK_WAIT, NULL);
}
//******************************************************************************
void CMenu1::UnlockBuffers()
{
	lpDDColor.m_lpDDS->Unlock(NULL);
	screen.m_lpDDSBack->m_lpDDS->Unlock(NULL);
}
