/*******************************************************************************/
//  Bernard Lidicky - 1999
//  Hippo Games
//  PiskII
//  PiskII.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "PiskII.h"
// casti hry
#include "menu.h"
#include "bbuttonek.h"


#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


CPiskIIApp theApp;
CDXScreen screen;
CAlphaBlitter *alpha; // alpha kopirovac

CDXLink       link;
CDXLinkPlayer player;
CDXLinkPlayer opponent;
BOOL          connected = FALSE;
//XLinkPlayer players[10];
// {90508681-ACB9-11d3-8F74-A5B67763D0DB}
const GUID pikII_GUID = 
{ 0x90508681, 0xacb9, 0x11d3, { 0x8f, 0x74, 0xa5, 0xb6, 0x77, 0x63, 0xd0, 0xdb } };


/*******************************************************************************/
BEGIN_MESSAGE_MAP(CPiskIIApp, CWinApp)
	//{{AFX_MSG_MAP(CPiskIIApp)
	//}}AFX_MSG
END_MESSAGE_MAP()
/*******************************************************************************/
CPiskIIApp::CPiskIIApp()
{
	srand((unsigned)time(NULL));  // inicializace generatoru nahodnych cisel
	alpha = NULL;
	connected = FALSE;
}
/*******************************************************************************/
CPiskIIApp::~CPiskIIApp()
{
	if(alpha != NULL) delete alpha;

	t_kill = true;

	if(connected == TRUE) {
		link.m_DP->Close();
		connected = FALSE;
	}
}	
/*******************************************************************************/
BOOL CPiskIIApp::InitInstance()
{
	ZobrazKurzor(FALSE);
#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	SetRegistryKey(_T("Hippo Games")); // nastaveni klice k registrum

	CMainFrame* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;
	pFrame->ShowWindow(SW_SHOW);

	// CDX init
//	if (screen.CreateFullScreen(m_pMainWnd->m_hWnd,640,480,16)  == FALSE) return FALSE;
	if (screen.CreateWindowed(m_pMainWnd->m_hWnd,640,480)  == FALSE) return FALSE;
	screen.FadeToBlack(0);
	
	// alpha blittear 
	DDPIXELFORMAT  pix;
   ZeroMemory(&pix, sizeof(pix));
   pix.dwSize = sizeof(pix);
	screen.m_lpDDSFront->m_lpDDS->GetPixelFormat(&pix);
	alpha = NewAlphaBlitter(pix);
	if(alpha == NULL) return FALSE;
	
	// link

	pFrame->UpdateWindow();
	pFrame->SendMessage(WM_INITED); // oznamime inicializaci

	return TRUE;
}
/*******************************************************************************/
int Nahoda(int kolik)
{
	return (rand()*kolik/RAND_MAX);
}
/******************************************************************************/
double abs(double co){
	if(co >= 0) return co;
	return -co;
}
/******************************************************************************/
void ZobrazKurzor(BOOL yes){
	static int sh = 0;
	if(yes == TRUE) while(sh < 0){ 
		ShowCursor(TRUE); 
		sh++;
	}
	else while(sh >= 0){ 
		ShowCursor(FALSE); 
		sh--;
	}
}
