/*==========================================================================
 *
 *  Copyright (C) 1995 Microsoft Corporation. All Rights Reserved.
 *
 *  File:       ddutils.cpp
 *  Content:    Routines for loading bitmap and palettes from resources
 *
 ***************************************************************************/
#ifndef DDUTILINC
#define DDUTILINC
#ifdef __cplusplus
extern "C" {            /* Assume C declarations for C++ */
#endif	/* __cplusplus */

extern IDirectDrawSurface * DDLoadBitmapB(IDirectDraw *pdd, LPCSTR szBitmap, int dx, int dy, HINSTANCE module = NULL);
extern HRESULT              DDReLoadBitmapB(IDirectDrawSurface *pdds, LPCSTR szBitmap, HINSTANCE module = NULL);
extern DWORD                DDColorMatchB(IDirectDrawSurface *pdds, COLORREF rgb);
extern HRESULT              DDSetColorKeyB(IDirectDrawSurface *pdds, COLORREF rgb);

#ifdef __cplusplus
}
#endif	/* __cplusplus */
#endif