/*******************************************************************************/
//  Bernard Lidicky - 1999
//  Hippo Games
//  PiskII
//  Modul4.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "piskII.h"
#include "hra.h"
#include "CreateCon.h"
#include "modul4.h"

/*
 Network - posloucha zpravy	
*/


HANDLE m4_event;

UINT m4_t_ConnServer(LPVOID p_CCreateCon){
	unsigned long i;
	t_kill = false;
	t_hotovo = false;
	t_running = true;

	st_message data;
	DWORD      size;

	CCreateCon *p_dlg = (CCreateCon*) p_CCreateCon;
	
	while (WaitForSingleObject(m4_event,100) != WAIT_OBJECT_0) {
		Sleep(100);
		if(t_kill) {
			t_running = false;
			return 0;
		}
	}
	
	link.Receive(&opponent.m_ID, &i, DPRECEIVE_FROMPLAYER,&data,&size);
	data.message = MESS_TEST;
	link.Send(player.m_ID,opponent.m_ID,DPSEND_GUARANTEED,&data,sizeof(data));

	TRACE("calling clientOK\n");
	p_dlg->ServerOK();

	t_running = false;
	return 0;
}

UINT m4_t_ConnClient(LPVOID p_CCreateCon){

	TRACE("Cliant Thread..\n");
	unsigned long i;

	t_kill = false;
	t_hotovo = false;
	t_running = true;

	st_message data;
	DWORD      size;

	CCreateCon *p_dlg = (CCreateCon*) p_CCreateCon;

	TRACE("Sending data\n");
	// oznamime servru pritomnost
	data.message = MESS_TEST;
	link.Send(player.m_ID,DPID_SERVERPLAYER,DPSEND_GUARANTEED,&data,sizeof(data));

	TRACE("Waiting for answer\n");
	while (WaitForSingleObject(m4_event,100) != WAIT_OBJECT_0) {
		Sleep(100);
		if(t_kill) {
			t_running = false;
			return 0;
		}
	}
	
	TRACE("Reading answer\n");
	// pockame na odpoved
	link.Receive(&opponent.m_ID, NULL, DPRECEIVE_FROMPLAYER,NULL,NULL);

	TRACE("calling clientOK\n");
	p_dlg->ClientOK();

	TRACE("DONE\n");
	t_running = false;
	return 0;
}


UINT m4_t_Tahni(LPVOID p_hra){
	TRACE("MODUL 4\n");
	unsigned long i,j;
	unsigned long size;

	byte  buffer[100];

	t_kill = false;
	t_hotovo = false;
	t_running = true;

	CHra *h = (CHra*) p_hra;
	srand(h->m_rand);

	TRACE("Receive tread started\n");

// message loop
	for(;;){
//		if(WaitForSingleObject(m4_event,100) == WAIT_OBJECT_0) {
		Sleep(100);
		size = 100 * sizeof(byte);
		if( link.Receive(NULL,NULL,DPRECEIVE_ALL,&buffer,&size) == DP_OK) {
			TRACE("MESSAGE..");
			if(buffer[0] != H_MESSAGE) continue;
			switch(buffer[1]){
			case MESS_TAH :
				if(buffer[2] == h->m_tahne)
					h->Tahnul(CPoint(buffer[3],buffer[4]));
				TRACE("Tah");
				continue;
			case MESS_MYS :
					h->m_plr.x = buffer[3];
					h->m_plr.y = buffer[4];
					h->m_toredraw = 0;
				TRACE("Mys");
				continue;
			case MESS_END :
				h->Done();
				TRACE("Hotovo");
				continue;
			}
			TRACE("/n");
		}
//		if (t_kill) break;
	}

	TRACE("EXIT THREAD\n");
	t_running = false;
	h->m_thread = NULL;
	return 0;
}
